﻿#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.3.14.2
	Autor:         dasda

	Skript Funktion:
	Filminformationen zur Anreicherung des Neutrino-Moviebrowsers herunterladen/erstellen.
	Für eine schönere Ansicht im MB werden die Filmcover und Filminformationen von filmstarts.de geladen.
	Zusätzlich wird mit den auf filmstarts.de gefundenen Titeln nach Informationen, wie Rating, auf IMDb gesucht
	Zusätzlich können Datei-Eigenschaften per MediaInfo_i386.dll gespeichert werden.

#ce ----------------------------------------------------------------------------

#include "includes.au3"

Global $sVersion = '1.3'
Global $sName = "Video_Info_Grabber" & " " & $sVersion

Global $sVBSPath = StringTrimRight(@ScriptDir, 3)
DirCreate($sVBSPath & "Data")
Global $Ini = $sVBSPath & "Data\Einstellungen.txt"

OnAutoItExitRegister("_Exit")

; Wenn keine ini vorhanden ist, wird sie erstellt und das Programm beendet.
If Not FileExists($Ini) Then _WriteIni()

; Wenn die MediaInfo.dll nicht vorhanden ist, wird eine Benachrichtigung eingeblendet und das Programm beendet.
If Not FileExists($sVBSPath & "Other\\MediaInfo_i386.dll") Then
	Exit MsgBox(0, "Fehlende Datei!", "MediaInfo_i386.dll fehlt im Programmverzeichnis." & @CRLF & "Das Programm wird beendet.", 10)
EndIf

TraySetIcon($sVBSPath & "\Other\Icon.ico")
Break(0) ; Deaktiviert das Tray-Icon - es reagiert nicht mehr auf Klicks.

; In den nächsten Zeilen wird erst geprüft, ob eine Programmverknüpfung im Verzeichnis der .vbs liegt. Wenn nicht werden dort und auf dem Desktop Verknüpfungen erstellt.

$sShortcutFPath1 = @DesktopDir & "\" & $sName & ".lnk"
$sShortcutFPath2 = $sVBSPath & $sName & ".lnk"
$aDetails = FileGetShortcut($sShortcutFPath2)
If @error Then
	FileCreateShortcut($sVBSPath & "Video_Info_Grabber.vbs", $sShortcutFPath1, @WindowsDir, "", _
			"Video-Informationen für den Moviebrowser erstellen", $sVBSPath & "\Other\Icon.ico", "^!t")
	FileCreateShortcut($sVBSPath & "Video_Info_Grabber.vbs", $sShortcutFPath2, @WindowsDir, "", _
			"Video-Informationen für den Moviebrowser erstellen", $sVBSPath & "\Other\Icon.ico", "^!t")
	MsgBox(0, $sName, "Es wurden Programmverknüpfungen im Programmverzeichnis und auf dem Desktop erstellt." & @CRLF & @CRLF & "Zum erneuten Erstellen die Verknüpfung im Programmverzeichnis löschen.")
EndIf


; Das MediaInfo Handle wird erstellt.
Global $hDLL = DllOpen($sVBSPath & "\Other\MediaInfo_i386.dll")
Global $aMediaInfo = DllCall($hDLL, "ptr", "MediaInfo_New")
Global $hMediaInfo = $aMediaInfo[0]

; Die Einstellungen werden in Variablen gelesen.
Global $sNoConfirmation = IniRead($Ini, "Einstellungen", "Automatik", "")
Global $sResolve = IniRead($Ini, "Einstellungen", "Dateinamenbereinigung", "")
Global $sUnderlines = IniRead($Ini, "Einstellungen", "Unterstriche", "")
Global $sExtInfo = IniRead($Ini, "Einstellungen", "Dateibeschreibung", "")
Global $sMediaInfoText = IniRead($Ini, "Einstellungen", "MediaInfotext", "")
Global $sRecursive = IniRead($Ini, "Einstellungen", "Rekursive Suche", "")
Global $sAudioInfos = IniRead($Ini, "Einstellungen", "Tonspuren", "")
Global $sChannelMask = IniRead($Ini, "Einstellungen", "Sendernamenfilter", "")
Global $sIP = IniRead($Ini, "Einstellungen", "IP", "")
Global $sCharset = IniRead($Ini, "Einstellungen", "UTF8", "")
Global $sStartfolder = IniRead($Ini, "Einstellungen", "Startverzeichnis", "")
Global $sOutputFilter = IniRead($Ini, "Einstellungen", "Cover/XML", "")
Global $sInfo1Option = IniRead($Ini, "Einstellungen", "Info1", "")
Global $sNoExtraFolder = IniRead($Ini, "Einstellungen", "Ergebnisse in das Filmverzeichnis", "")
Global $sIMDbInfos = IniRead($Ini, "Einstellungen", "IMDb", "")
Global $mediainfo = IniRead($Ini, "Einstellungen", "MediaInfo", "")
Global $archiv = IniRead($Ini, "Einstellungen", "Archivieren", "")


; Einige Arrays die ich für Filterfunktionen nutze. $aSubstitutes etwa ist der Filter, um letzte html-tags aus den Filminformationen zu löschen.
Global $aSubstitutes[17][2] = [["<br />", ""], ["<b>", ""], ["</b>", ""], ["</a>", ""], ["<a href='", ""], ["'><img", ""], ["src='", ""], ["'", ""], ["<br>", ""], _
		["</br>", ""], [">", ""], ["<span", ""], ["</span", ""], ["</p", ""], ["<p", ""], ["&nbsp;", " "], ["<br/", ""]]
Global $aMoviefilter[7][1] = [[".mkv"], [".ts"], [".avi"], [".divx"], [".mpg"], [".mp4"], [".mpeg"]]
Global $aWindowsCleanup[9][1] = [['/'], ['\'], [':'], ['*'], ['"'], ['?'], ['>'], ['<'], ['|']]
Global $aGenreNumbers[23][2] = [["Spielfilm", "16"], ["Drama", "16"], ["Krimi", "17"], ["Thriller", "17"], ["Action", "18"], ["Abenteuer", "18"], ["Western", "18"], ["Kriegsfilm", "18"], _
		["Sci-Fi", "19"], ["Fantasy", "19"], ["Horror", "19"], ["Romanze", "22"], ["Tragigkomödie", "20"], ["Komödie", "20"], ["Historie", "23"], ["Animation", "85"], _
		["Familie", "16"], ["Spionage", "17"], ["Dokumentation", "28"], ["Sport", "34"], ["Biografie", "131"], ["Musik", "96"]]
Global $aAscii[10][2] = [['Ü', '%C3%9C'], ['ü', '%C3%BC'], ['Ö', '%C3%96'], ['ö', '%C3%B6'], ['Ä', '%C3%84'], ['ä', '%C3%A4'], [':', '%3A'], ['ß', '%C3%9F'], ['"', ''], ['&', '%26']]

; Ignorierliste wird in ein Array geladen.
Global $hIgnorelist = $sVBSPath & "Data\Ignorierliste.txt"

; Einige Deklarationen für später gebrauchte Variablen
Global $aFolder = "", $sDrive = "", $sDir = "", $sFilename = "", $sExtension = "", $sDuration = "", $sExtFileData = "", $aMovies = "", $iFoundMovies = "", $iSearchlines = ""
Global $sIMDb_Infos = "", $filmstart_Infos = "", $WritefLine = "", $sIMDbID = "", $sSoundtrack = "", $sReleaseYear = "", $sCountry = "", $sRating = "", $iGlobalRun = ""

DirCreate($sVBSPath & "Archiv")
Global $hArchivFolder = $sVBSPath & "Archiv"


#Region ### START Koda GUI section ### Form=D:\User\Desktop\programmieren\autoit\Projekte\vidgrab\Form1.kxf
Global $h_gui = GUICreate($sName & ' - Einstellungen', 374, 464, -1, -1, BitOR($WS_EX_TOOLWINDOW, $WS_EX_WINDOWEDGE))
Global $h_StandardFolderSel = GUICtrlCreateButton("Standardordner", 15, 15, 150, 25)
Global $h_Standardfolder = GUICtrlCreateCheckbox("Immer Standardverzeichnis", 180, 20, 150, 17)
Global $h_SearchFolder = GUICtrlCreateButton("Suchordner", 15, 50, 150, 25)
Global $h_Rekursiv = GUICtrlCreateCheckbox("Rekursive Suche", 180, 56, 105, 17)
Global $h_actFolder = GUICtrlCreateLabel("", 15, 80, 300, 32)
Global $h_saveIcon = GUICtrlCreateIcon($sVBSPath & '\Other\Save.ico', -1, 319, 64, 32, 32)
Global $h_Automatik = GUICtrlCreateCombo('', 16, 120, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
Global $h_cover_xml = GUICtrlCreateCombo('', 208, 120, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
Global $h_SaveMovieDir = GUICtrlCreateCombo('', 208, 168, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
Global $h_Filerename = GUICtrlCreateCombo('', 16, 168, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
Global $h_reset_ignorelist = GUICtrlCreateButton("Ignorierliste zurücksetzen", 208, 264, 147, 25)
Global $h_Info1 = GUICtrlCreateCombo('', 208, 218, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
Global $h_Beschreibung = GUICtrlCreateCombo('', 16, 218, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
Global $h_Sendernamenfilter = GUICtrlCreateCombo('', 16, 320, 145, 25, BitOR($CBS_DROPDOWNLIST, $CBS_AUTOHSCROLL))
Global $h_IPAddress = _GUICtrlIpAddress_Create($h_gui, 208, 320, 146, 21)
Global $h_start = GUICtrlCreateButton("Starten", 16, 376, 147, 30)

Global $h_beenden = GUICtrlCreateButton("Beenden", 208, 376, 147, 30)
Global $h_Hinweis = GUICtrlCreateLabel("Weitere Optionen können in der Einstellungen.txt vorgenommen werden.", 0, 416, 374, 17, $SS_CENTER)
Global $h_Log = GUICtrlCreateEdit("", 8, 464, 337, 281, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_READONLY, $ES_WANTRETURN, $ES_CENTER))
#EndRegion ### END Koda GUI section ###

_MainGUI()

Func _MainGUI()
	#Region ### Beschreibungen
	Local $hInfo1 = GUICtrlGetHandle($h_Info1)
	Local $hSearchFolder = GUICtrlGetHandle($h_SearchFolder)
	Local $hStandardFolderSel = GUICtrlGetHandle($h_StandardFolderSel)
	Local $hStandardFolder = GUICtrlGetHandle($h_Standardfolder)
	Local $hRekursiv = GUICtrlGetHandle($h_Rekursiv)
	Local $hsaveIcon = GUICtrlGetHandle($h_saveIcon)
	Local $hAutomatik = GUICtrlGetHandle($h_Automatik)
	Local $hcover_xml = GUICtrlGetHandle($h_cover_xml)
	Local $hSaveMovieDir = GUICtrlGetHandle($h_SaveMovieDir)
	Local $hFilerename = GUICtrlGetHandle($h_Filerename)
	Local $hBeschreibung = GUICtrlGetHandle($h_Beschreibung)
	Local $hSendernamenfilter = GUICtrlGetHandle($h_Sendernamenfilter)
	Local $hreset_ignorelist = GUICtrlGetHandle($h_reset_ignorelist)

	Local $hTip_StandardFolderSel = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_StandardFolderSel, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_StandardFolderSel, 600)
	_GUIToolTip_SetDelayTime($hTip_StandardFolderSel, 2, 30000)
	_GUIToolTip_SetTitle($hTip_StandardFolderSel, 'Standard-Ordner')
	_GUIToolTip_AddTool($hTip_StandardFolderSel, 0, 'Hier kann der Standardordner für die Ordnerauswahl der Suche festgelegt werden.' & @CRLF & _
			'Voreinstellung ist das Programmverzeichnis', $hStandardFolderSel, 0, 10, 600, 430)

	Local $hTip_StandardFolder = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_StandardFolder, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_StandardFolder, 600)
	_GUIToolTip_SetDelayTime($hTip_StandardFolder, 2, 30000)
	_GUIToolTip_SetTitle($hTip_StandardFolder, 'Immer Standardverzeichnis')
	_GUIToolTip_AddTool($hTip_StandardFolder, 0, 'Wenn angehakt, startet der Grabber immer im Standardverzeichnis.' & @CRLF & _
			'Andernfalls ist das letzte Suchverzeichnis der Ausgangspunkt.', $hStandardFolder, 0, 10, 600, 430)

	Local $hTip_SearchFolder = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_SearchFolder, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_SearchFolder, 600)
	_GUIToolTip_SetDelayTime($hTip_SearchFolder, 2, 30000)
	_GUIToolTip_SetTitle($hTip_SearchFolder, 'Start-Ordner der Suche')
	_GUIToolTip_AddTool($hTip_SearchFolder, 0, 'Wähle hier den Ordner aus, in dem deine Filme und Unterordner liegen.', $hSearchFolder, 0, 10, 600, 430)

	Local $hTip_hreset_ignorelist = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hreset_ignorelist, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hreset_ignorelist, 600)
	_GUIToolTip_SetDelayTime($hTip_hreset_ignorelist, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hreset_ignorelist, 'Ignorierliste löschen')
	_GUIToolTip_AddTool($hTip_hreset_ignorelist, 0, 'Das Programm führt eine Suchliste, damit einmal gefundene Filme nicht erneut gesucht werden. Hiermit kann man die Liste löschen.', $hreset_ignorelist, 0, 10, 600, 430)

	Local $hTip_hRekursiv = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hRekursiv, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hRekursiv, 600)
	_GUIToolTip_SetDelayTime($hTip_hRekursiv, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hRekursiv, 'Rekursive Suche')
	_GUIToolTip_AddTool($hTip_hRekursiv, 0, 'Ein Wert 1 bei "Rekursive Suche" sorgt dafür, dass auch Unterordner durchsucht werden.' & @CRLF & 'Bei 0, bleibt die Suche auf den gewählten Ordner beschränkt).', $hRekursiv, 0, 10, 600, 430)

	Local $hTip_hsaveIcon = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hsaveIcon, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hsaveIcon, 600)
	_GUIToolTip_SetDelayTime($hTip_hsaveIcon, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hsaveIcon, 'Filmlisten speichern')
	_GUIToolTip_AddTool($hTip_hsaveIcon, 0, 'Hiermit kannst du dir Filmlisten zur aktuellen Suche erstellen.' & @CRLF & 'Es werden 3 Listen gespeichert (Titel/rel. Pfade/kompl. Pfade).', $hsaveIcon, 0, 10, 600, 430)

	Local $hTip_hAutomatik = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hAutomatik, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hAutomatik, 600)
	_GUIToolTip_SetDelayTime($hTip_hAutomatik, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hAutomatik, 'Automatik (Filter für Rückfragen des Programms)')
	_GUIToolTip_AddTool($hTip_hAutomatik, 0, 'Der Wert 1 bei "Automatik" sorgt für die direkte Übernahme wenn nur einer der Treffer wortgleich ist.' & @CRLF & _
			'Wird hier der Wert 2 eingetragen, werden Filme auch übernommen, wenn das Ergebnis eindeutig scheint, weil nur ein Suchtreffer gefunden wurde.' & @CRLF & _
			'Bei Wert 3 bearbeitet das Programm in Batchverarbeitung jeden eindeutigen, wortgleichen Treffer und übergeht die anderen.' & @CRLF & _
			'Bei Wert 4 übernimmt das Programm in Batchverarbeitung jeden wortgleichen Treffer und alle Einzeltreffer. Alle anderen werden übergangen.', $hAutomatik, 0, 10, 600, 430)

	Local $hTip_hcover_xml = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hcover_xml, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hcover_xml, 600)
	_GUIToolTip_SetDelayTime($hTip_hcover_xml, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hcover_xml, 'Cover/XML')
	_GUIToolTip_AddTool($hTip_hcover_xml, 0, 'Bei Wert 1 bei "Cover/XML" werden Cover geladen und XML erstellt.' & @CRLF & 'Bei Wert 2 werden nur die Cover geladen.' & @CRLF & _
			'Bei Wert 3 werden nur die XML erstellt.', $hcover_xml, 0, 10, 600, 430)

	Local $hTip_hSaveMovieDir = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hSaveMovieDir, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hSaveMovieDir, 600)
	_GUIToolTip_SetDelayTime($hTip_hSaveMovieDir, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hSaveMovieDir, 'Ergebnisse in das Filmverzeichnis (Überschreibt vorhandene Daten!)')
	_GUIToolTip_AddTool($hTip_hSaveMovieDir, 0, 'Bei Wert 1 von "Ergebnisse in das Filmverzeichnis" werden die heruntergeladenen Filminformationen' & @CRLF & _
			'nicht in einem getrennten Ergebnisordner abgelegt werden, sondern direkt bei der Filmdatei.', $hSaveMovieDir, 0, 10, 600, 430)

	Local $hTip_hFilerename = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hFilerename, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hFilerename, 600)
	_GUIToolTip_SetDelayTime($hTip_hFilerename, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hFilerename, 'Dateinamenbereinigung - Datei in Originaltitel umbenennen')
	_GUIToolTip_AddTool($hTip_hFilerename, 0, 'Der Wert 1 bei "Dateinamenbereinigung" bedeutet, dass der gefundene Titel als neuer Dateiname verwendet wird.' & @CRLF & _
			'Wenn du in der umbenannten Datei Unterstriche statt Leerzeichen haben möchte, muss das in der Einstellungen.txt geändert werden.', $hFilerename, 0, 10, 600, 430)

	Local $hTip_hInfo1 = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hInfo1, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hInfo1, 600)
	_GUIToolTip_SetDelayTime($hTip_hInfo1, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hInfo1, 'Info1')
	_GUIToolTip_AddTool($hTip_hInfo1, 0, 'Bei Wert 0 bleibt Info1 leer.' & @CRLF & 'Bei Wert 1 von "Info1" bietet das Programm an, einen Titel, der : oder - ' & _
			'beinhaltet aufzusplitten und den ersten Teil als Namen, den zweiten Teil als Info1' & @CRLF & _
			'Standard ist Wert 2: Hier werden automatisch die Grenreangaben als Info1 übernommen, wie es oft bei Aufnahmen der Fall ist.', $hInfo1, 0, 10, 600, 430)

	Local $hTip_hBeschreibung = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hBeschreibung, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hBeschreibung, 600)
	_GUIToolTip_SetDelayTime($hTip_hBeschreibung, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hBeschreibung, 'Dateibeschreibung (MediaInfo-Daten an Info2 anhängen.)')
	_GUIToolTip_AddTool($hTip_hBeschreibung, 0, 'Der Wert 1 bei "Dateibeschreibung" sorgt dafür, dass Info 2 noch zusätzliche Informationen angehängt werden (Container, Codec, Auflösung und Video-Bitrate).', $hBeschreibung, 0, 10, 600, 430)

	Local $hTip_hSendernamenfilter = _GUIToolTip_Create(0, BitOR($TTS_NOPREFIX, $TTS_BALLOON))
	_WinAPI_SetWindowTheme($hTip_hSendernamenfilter, "", "")
	_GUIToolTip_SetMaxTipWidth($hTip_hSendernamenfilter, 600)
	_GUIToolTip_SetDelayTime($hTip_hSendernamenfilter, 2, 30000)
	_GUIToolTip_SetTitle($hTip_hSendernamenfilter, 'Sendernamenfilter')
	_GUIToolTip_AddTool($hTip_hSendernamenfilter, 0, 'Der Wert 1 bei "Sendernamenfilter" sorgt für das Filtern der Sendernamen aus dem Suchbegriff.' & @CRLF & _
			'Vorraussetzung hierfür ist die Angabe der IP Adresse eines Receivers, von dem die Senderliste abgerufen werden kann.' & @CRLF & _
			'Bei Problemen kann Zeichensatz UTF8 (UTF8=1) in der Einstellungen.txt ausprobiert werden.', $hSendernamenfilter, 0, 10, 600, 430)

	#EndRegion ### Beschreibungen

	GUICtrlSetState($h_saveIcon, $GUI_HIDE)
	If $sStartfolder == "" Then
		GUICtrlSetState($h_start, $GUI_DISABLE)
	Else
		_FolderSearch($sStartfolder)
		GUICtrlSetData($h_actFolder, $sStartfolder & ' (' & $iFoundMovies & ' Filme)')
		If $iFoundMovies > 0 Then
			GUICtrlSetState($h_start, $GUI_ENABLE)
			GUICtrlSetState($h_saveIcon, $GUI_SHOW)
		Else
			GUICtrlSetState($h_start, $GUI_DISABLE)
			GUICtrlSetState($h_saveIcon, $GUI_HIDE)
		EndIf
	EndIf

	GUICtrlSetData($h_Info1, 'Info1=0|Info1=1|Info1=2|', 'Info1=' & $sInfo1Option)
	GUICtrlSetData($h_Automatik, 'Automatik=0|Automatik=1|Automatik=2|Automatik=3|Automatik=4|', 'Automatik=' & $sNoConfirmation)
	GUICtrlSetData($h_cover_xml, 'Cover/XML=1|Cover/XML=2|Cover/XML=3|', 'Cover/XML=' & $sOutputFilter)
	GUICtrlSetData($h_Sendernamenfilter, 'Sendernamenfilter=0|Sendernamenfilter=1|', 'Sendernamenfilter=' & $sChannelMask)
	GUICtrlSetData($h_SaveMovieDir, 'Überschreiben=0|Überschreiben=1|', 'Überschreiben=' & $sNoExtraFolder)
	GUICtrlSetData($h_Filerename, 'Dateiname=0|Dateiname=1|', 'Dateiname=' & $sResolve)
	GUICtrlSetData($h_Beschreibung, '|MediaInfo in Info2=0|MediaInfo in Info2=1|', 'MediaInfo in Info2=' & $sExtInfo)
	_GUICtrlIpAddress_Set($h_IPAddress, $sIP)

	GUISetState(@SW_SHOW)

	If $sRecursive = 1 Then
		GUICtrlSetState($h_Rekursiv, $GUI_CHECKED)
	Else
		GUICtrlSetState($h_Rekursiv, $GUI_UNCHECKED)
	EndIf

	Local $sStandardfolder = IniRead($Ini, "Einstellungen", "Standardverzeichnis", StringTrimRight(@ScriptDir, 4))
	If Not FileExists($sStandardfolder) Then $sStandardfolder = ".\" & StringTrimRight(@ScriptDir, 4)
	If IniRead($Ini, "Einstellungen", "Immer Standardverzeichnis", "") Then
		GUICtrlSetState($h_Standardfolder, $GUI_CHECKED)
	Else
		GUICtrlSetState($h_Standardfolder, $GUI_UNCHECKED)
	EndIf


	Local $aGuiArray[19][1] = [[$h_StandardFolderSel], [$h_Standardfolder], [$h_SearchFolder], [$h_Rekursiv], [$h_actFolder], [$h_saveIcon], [$h_Automatik], [$h_cover_xml], [$h_SaveMovieDir], [$h_Filerename], [$h_reset_ignorelist], [$h_Info1], _
			[$h_Beschreibung], [$h_Sendernamenfilter], [$h_start], [$h_beenden], [$h_Hinweis]]

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $h_SearchFolder
				$iFoundMovies = 0
				If Not FileExists($sStartfolder) Or _IsChecked($h_Standardfolder) Then $sStartfolder = $sStandardfolder
				Global $sFileOpenDialog = FileSelectFolder("Wähle einen Filme-Ordner aus", $sStartfolder & "\", "All (*.*)")
				If @error Then
					GUICtrlSetData($h_actFolder, $sFileOpenDialog)
					GUICtrlSetState($h_start, $GUI_DISABLE)
				Else
					_FolderSearch($sFileOpenDialog)
					GUICtrlSetData($h_actFolder, $sFileOpenDialog & ' (' & $iFoundMovies & ' Filme)')
					; Das ausgewählte Verzeichnis wird für zukünftige Starts gespeichert.
					If $sStartfolder <> $sFileOpenDialog Then IniWrite($Ini, "Einstellungen", "Startverzeichnis", $sFileOpenDialog)
				EndIf
				If $iFoundMovies > 0 Then
					GUICtrlSetState($h_start, $GUI_ENABLE)
					GUICtrlSetState($h_saveIcon, $GUI_SHOW)
				Else
					GUICtrlSetState($h_start, $GUI_DISABLE)
					GUICtrlSetState($h_saveIcon, $GUI_HIDE)
				EndIf
			Case $h_StandardFolderSel
				$sStandardfolder = FileSelectFolder("Wähle das Standard-Startverzeichnis", $sStandardfolder & "\", "All (*.*)")
				If Not @error Then
					; Das ausgewählte Verzeichnis wird für zukünftige Starts gespeichert.
					IniWrite($Ini, "Einstellungen", "Standardverzeichnis", $sStandardfolder)
				EndIf
			Case $h_Standardfolder
				If _IsChecked($h_Standardfolder) Then
					IniWrite($Ini, "Einstellungen", "Immer Standardverzeichnis", 1)
				Else
					IniDelete($Ini, "Einstellungen", "Immer Standardverzeichnis")
				EndIf
			Case $h_Rekursiv
				If _IsChecked($h_Rekursiv) Then
					$sRecursive = 1
				Else
					$sRecursive = 0
				EndIf
				IniWrite($Ini, "Einstellungen", "Rekursive Suche", $sRecursive)
			Case $h_reset_ignorelist
				FileDelete($hIgnorelist)
			Case $h_start
				_SaveSettings()
				For $i = 0 To 15
					GUICtrlSetState($aGuiArray[$i][0], $GUI_DISABLE)
					GUICtrlSetState($aGuiArray[$i][0], $GUI_HIDE)
				Next
				_GUICtrlIpAddress_Destroy($h_IPAddress)
				GUICtrlSetPos($h_Log, 0, 0, 374, 464)
				WinMove($h_gui, $sName & ' - Einstellungen', @DesktopWidth / 2 + 20, @DesktopHeight / 2 - 240)
				_Suchschleife()
			Case $h_beenden
				_SaveSettings()
				Exit
			Case $h_saveIcon
				Global $sFolderToSave = FileSelectFolder("Filmliste speichern", @DesktopDir & "\", "All (*.*)")
				If Not @error Then _SaveLists()
		EndSwitch
	WEnd
EndFunc   ;==>_MainGUI


Func _SaveSettings()
	$sInfo1Option = StringTrimLeft(GUICtrlRead($h_Info1), 6)
	$sNoConfirmation = StringTrimLeft(GUICtrlRead($h_Automatik), 10)
	$sOutputFilter = StringTrimLeft(GUICtrlRead($h_cover_xml), 10)
	$sNoExtraFolder = StringTrimLeft(GUICtrlRead($h_SaveMovieDir), 14)
	$sResolve = StringTrimLeft(GUICtrlRead($h_Filerename), 10)
	$sIP = _GUICtrlIpAddress_Get($h_IPAddress)
	$sExtInfo = StringTrimLeft(GUICtrlRead($h_Beschreibung), 19)
	$sChannelMask = StringTrimLeft(GUICtrlRead($h_Sendernamenfilter), 18)

	IniWrite($Ini, "Einstellungen", "Info1", $sInfo1Option)
	IniWrite($Ini, "Einstellungen", "Automatik", $sNoConfirmation)
	IniWrite($Ini, "Einstellungen", "Cover/XML", $sOutputFilter)
	IniWrite($Ini, "Einstellungen", "Ergebnisse in das Filmverzeichnis", $sNoExtraFolder)
	IniWrite($Ini, "Einstellungen", "Dateinamenbereinigung", $sResolve)
	IniWrite($Ini, "Einstellungen", "Dateibeschreibung", $sExtInfo)
	IniWrite($Ini, "Einstellungen", "Sendernamenfilter", $sChannelMask)
	IniWrite($Ini, "Einstellungen", "IP", $sIP)
EndFunc   ;==>_SaveSettings

Func _SaveLists()
	Local $aPathSplit, $sTDrive, $sTDir, $sTFilename, $sTExtension

	; Hier werden die drei Textdateien erstellt
	$sMovielistFull = FileOpen($sFolderToSave & '\Filmliste - komplette Pfade.txt', 2)
	FileWrite($sMovielistFull, $iFoundMovies & ' Filme' & @CRLF & 'Startordner der Suche: ' & $sFileOpenDialog & @CRLF & '------------------------------------')
	For $i = 1 To UBound($aMovies) - 1
		FileWrite($sMovielistFull, @CRLF & $aMovies[$i])
	Next

	$sMovielistRel = FileOpen($sFolderToSave & '\Filmliste - relative Pfade.txt', 2)
	FileWrite($sMovielistRel, $iFoundMovies & ' Filme' & @CRLF & 'Startordner der Suche: ' & $sFileOpenDialog & @CRLF & '------------------------------------')
	For $i = 1 To UBound($aMovies) - 1
		$Text = StringReplace($aMovies[$i], $sFileOpenDialog & '\', '')
		FileWrite($sMovielistRel, @CRLF & $Text)
	Next

	$sMovielistTitle = FileOpen($sFolderToSave & '\Filmliste - nur Titel.txt', 2)
	FileWrite($sMovielistTitle, $iFoundMovies & ' Filme' & @CRLF & 'Startordner der Suche: ' & $sFileOpenDialog & @CRLF & '------------------------------------')
	For $i = 1 To UBound($aMovies) - 1
		$aPathSplit = _PathSplit($aMovies[$i], $sTDrive, $sTDir, $sTFilename, $sTExtension)
		FileWrite($sMovielistTitle, @CRLF & $sTFilename)
	Next

	FileClose($sMovielistFull)
	FileClose($sMovielistTitle)
	FileClose($sMovielistRel)
EndFunc   ;==>_SaveLists

Func _FolderSearch($sFileOpenDialog)

	; Hier wird geprüft, ob die rekursive Suche aktiviert ist, und je nachdem wird die entsprechende Suche gestartet.
	If $sRecursive = 1 Then
		$aFolder = _FileListToArrayRec($sFileOpenDialog, "*", $FLTAR_FILES, $FLTAR_RECUR, $FLTAR_NOSORT, $FLTAR_FULLPATH)
	Else
		$aFolder = _FileListToArrayRec($sFileOpenDialog, "*", $FLTAR_FILES, $FLTAR_NORECUR, $FLTAR_NOSORT, $FLTAR_FULLPATH)
	EndIf

	; In dieser Schleife werden aus den gefundenen Dateien, die in $aMoviefilter definierten Dateitypen gefiltert.
	Local $sMovies = ""
	For $i = 0 To UBound($aFolder) - 1
		For $j = 0 To 5
			If StringInStr($aFolder[$i], $aMoviefilter[$j][0]) Then
				$sMovies &= $aFolder[$i] & "|"
				ExitLoop
			EndIf
		Next
	Next

	; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
	If $sCharset = 1 Then
		$dBinary = StringToBinary($sMovies)
		$sMovies = BinaryToString($dBinary, 4)
	EndIf

	; Aus dem String wird ein Array gebildet.
	$aMovies = StringSplit($sMovies, "|")
	$iFoundMovies = UBound($aMovies) - 1
	If $aMovies[$iFoundMovies] = "" Then
		_ArrayDelete($aMovies, $iFoundMovies)
		$iFoundMovies -= 1
	EndIf
	If $sMovies = "" Then $iFoundMovies = 0
EndFunc   ;==>_FolderSearch

Func _Suchschleife()
	; In dieser Funktion wird die allgemeine Suche ausgeführt und die Suchergebnisse ausgewertet.

	; Hier wird der Senderlisten-Filter erstellt, wenn die entsprechende Option aktiviert ist.
	If $sChannelMask = 1 Then
		Local $sReceiverURL = "http://" & $sIP & "/control/channellist", $sChannellist = _INetGetSource($sReceiverURL, True)
		If Not @error Then
			; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
			$dBinary = StringToBinary($sChannellist)
			$sConverted = BinaryToString($dBinary, 4)

			Local $aChannellist = StringSplit($sConverted, @LF)
			_ArrayDelete($aChannellist, 0)
			$iSearchlines = UBound($aChannellist)

			Global $aChannels[$iSearchlines - 1]
			For $i = 0 To $iSearchlines - 2
				$aChannels[$i] = StringTrimLeft($aChannellist[$i], 17) ; Sendernamenfilter wird gefüllt.
			Next
			_ArraySort($aChannels, 1)
		Else
			$hErrorMSG = MsgBox(4, $sName, "Receiver ist nicht erreichbar." & @CRLF & @CRLF & "Soll ohne den Senderfilter fortgefahren werden?")
			If $hErrorMSG = 7 Then
				MsgBox(0, $sName, "Programm wird beendet.", 3)
				Exit
			Else
				$sChannelMask = 0
			EndIf
		EndIf
	EndIf

	Local $aIgnorelist = FileReadToArray($hIgnorelist)


	; Hier wird (nach Prüfungen) in Schleife die Suche nach allen gefilterten Dateitypen (Filmen) gestartet und einige umständliche Stringanpassungen vorgenommen.
	For $i = 1 To $iFoundMovies
		$iGlobalRun = $i
		If $aMovies[$i] <> "" Then ; Wenn Filme vorhanden sind.
			$aPathSplit = _PathSplit($aMovies[$i], $sDrive, $sDir, $sFilename, $sExtension)
			$sMoviename = StringReplace($sFilename, "_", " ") ; Hier werden erst _ dann . durch Leerzeichen ersetzt, um die Suchergebnisse zu verbessen.
			$sMoviename = StringReplace($sMoviename, ".", " ")
			If StringInStr($sMoviename, "(") And StringInStr($sMoviename, ")") Then ; Hier folgt das Entfernen des Inhalts von Klammern
				$aMoviesplit = _StringBetween($sMoviename, "(", ")")
				For $j = 0 To UBound($aMoviesplit) - 1
					$sMoviename = StringReplace($sMoviename, "(" & $aMoviesplit[$j] & ")", "", 1)
				Next
			EndIf
			If StringLen($sMoviename) > 15 And Number(StringRight($sMoviename, 14)) <> 0 Then ; Hier wird ein eventuell vorhandenes Datum entfernt
				If StringInStr(StringRight($sMoviename, 14), " ") Then
					$sMoviename = StringTrimRight($sMoviename, 15)
				Else
					$sMoviename = StringTrimRight($sMoviename, 14)
				EndIf
			EndIf
			If $sChannelMask = 1 Then $sMoviename = _ChannelCleanup($sMoviename)
			$sMoviename = StringReplace($sMoviename, "   ", " - ")
			$sMoviename = StringReplace($sMoviename, "  ", " ")

			Global $iIgnoreList = _ArraySearch($aIgnorelist, $sFilename) ; Hier wird geprüft, ob der aktuelle Film schon in der Ignorierliste steht.
			If @error And $sMediaInfoText <> 2 And $sMediaInfoText <> 3 Then _SearchMovies($sMoviename) ; ..wenn nicht (und der Batchmodus nicht aktiviert ist), wird die Suche gestartet.
			If $sMediaInfoText = 2 Or $sMediaInfoText = 3 Then _MediaInfo() ; Wenn der Batchmodus zum schreiben der MediaInfo-Datei-Informationen aktiviert ist, wird diese Ausgabe gestartet.
		EndIf
	Next
	GUICtrlSetData($h_Log, 'Suche abgeschlossen! Programm wird beendet..' & @CRLF & GUICtrlRead($h_Log))
	Sleep(3000)
	Exit

EndFunc   ;==>_Suchschleife

Func _SearchMovies($sMoviename)
	GUICtrlSetData($h_Log, $sMoviename & $sExtension & ' wird gesucht..' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
	$sSearchname = _ascii($sMoviename)
	Local $Adress = "http://www.filmstarts.de/suche/1/?q=" & StringReplace($sSearchname, " ", "+"), $sSearch = _INetGetSource($Adress, True)

	Local $aResults = _StringBetween($sSearch, 'Bitte Suche verfeinern :', '</div><!-- / searchenginezone -->')

	; Wenn $aResults ein Fehler ist, wurden keine Suchergebnisse geliefert
	If Not @error Then

		; Hier wird die Anzahl der gefundenen Filme ausgewertet
		$aTempSplit = StringSplit($aResults[0], "Treffer")
		$sCounttext = "Ergebnis"
		$iHits = $aTempSplit[1]
		If $iHits < 1 Or $iHits > 1 Then $sCounttext = "Ergebnisse"
		If $iHits <> 0 Then
			; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
			$dBinary = StringToBinary($aResults[0])
			$sConverted = BinaryToString($dBinary, 4)

			; Hier erstelle ich ein Array. (Der String wird beim Zeilenumbruch gesplittet)
			$aResultSplit = StringSplit($sConverted, @LF)
;~ _ArrayDisplay($aResultSplit, @ScriptLineNumber)
			; Die Arraygröße des Ergebnis-Array wird auf maximal 20 gesetzt (erste Trefferseite der Website)
			If $iHits > 20 Then $iHits = 20

			; Ergebnis-Array wird mit der Treffermenge deklariert.
			Local $aResultnames[$iHits][4]
			Local $aTestMovies[$iHits][1]

			; Damit zähle ich gleich den Index des Ergebnis-Array in der Schleife hoch
			Local $iCount = 0

			; Hier wird das $aResultSplit Array Zeile für Zeile durchgegangen. "alt='" im Quelltext nehme ich dabei als Marker für die gesuchten Informationen
			For $i = 0 To UBound($aResultSplit) - 1
				If StringInStr($aResultSplit[$i], "alt='") Then ; "alt='" in der Zeile $i gefunden wurde, befindet sich der Logolink eine Zeile darüber, der Filmname drei Zeilen darunter...

					; Hier wird getestet, ob nach "alt'" wirklich Text kommt. Nur dann finden sich Filminformationen.
					$aTestResults = _StringBetween($aResultSplit[$i], "'", "'")

					If $aTestResults[0] <> "" Then
						; Ergebnis-Array wird gefüllt, nachdem unerwünschte Zeichen entfernt wurden
						$aResultnames[$iCount][0] = _TextCleanup($aResultSplit[$i - 1]) ; Logolink
						$aResultnames[$iCount][1] = _TextCleanup($aResultSplit[$i + 3]) ; Filmname

						; Um bei der Suche auf filmstarts.de die Suchfenster auch genaue Treffer bei Titeln mit . oder : zu erreichen, werden die für die Prüfung entfernt.
						$DeleteD = StringReplace(_TextCleanup($aResultSplit[$i + 3]), '.', '')
						$DeleteDD = StringReplace($DeleteD, ':', '')
						$aTestMovies[$iCount][0] = $DeleteDD ; Filmname für Suchtest

						$aResultnames[$iCount][2] = "http://www.filmstarts.de" & _TextCleanup($aResultSplit[$i + 2]) ; Detail-Link.
						$LenTest = StringLen(_TextCleanup($aResultSplit[$i + 6]))
						If $LenTest = 4 Then $aResultnames[$iCount][3] = _TextCleanup($aResultSplit[$i + 6]) ; Jahr
						$LenTest = StringLen(_TextCleanup($aResultSplit[$i + 7]))
						If $LenTest = 4 Then $aResultnames[$iCount][3] = _TextCleanup($aResultSplit[$i + 7]) ; Jahr
						$iCount += 1
					EndIf
				EndIf
			Next
		EndIf
;~ _ArrayDisplay($aResultnames, @ScriptLineNumber)
		Local $iTop = 30, $idPic[$iHits], $idLabel[$iHits], $iIgnore = "", $iIndex = ""

		If $sNoConfirmation = 1 Or $sNoConfirmation = 2 Or $sNoConfirmation = 3 Or $sNoConfirmation = 4 Then
			; Hier wird für die automatische Übernahme ("Automatik") geprüft, ob in der Trefferliste ein genauer Treffer ist.
			If $iHits > 0 Then
				Local $aPerfectName = _ArrayFindAll($aTestMovies, $sMoviename, 0, 0, 0, 0)

				If Not @error Then
;~ 					_ArrayDisplay($aPerfectName, @ScriptLineNumber)
					; Wenn es nur einen Treffer mit korrektem Namen gibt, wird der Titel übernommen
					If UBound($aPerfectName) = 1 Then
						$iHits = 1
						$iIndex = $aPerfectName[0]
					EndIf
				EndIf


			EndIf

			; Hier wird $iIndex auf Null gesetzt, wenn es nur einen Suchtreffer gibt. So wird ein Titel auch übernommen, wenn es kein namensgleicher Treffer ist.
			If $sNoConfirmation = 2 Or $sNoConfirmation = 4 And $iHits = 1 Then $iIndex = 0

			; Hier wird geprüft, ob die Bedingungen für die "Automatik" gegeben sind (nur 1 Titel, oder ein genauer Treffer). Wenn das nicht der Fall ist, wird die GUI erstellt.
			If ($sNoConfirmation = 1 And $sNoConfirmation <> 3 And $iHits = 1 And $iIndex <> -1) Or ($sNoConfirmation <> 1 And $sNoConfirmation <> 3 And $iHits > 0 And $iIndex <> -1) Then
				GUICtrlSetData($h_Log, 'Beschreibung für ' & $aResultnames[$iIndex][1] & $sExtension & ' wird automatisch übernommen..' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
				If $sResolve = 1 And $sFilename & $sExtension <> _WindowsCleanup($aResultnames[$iIndex][1]) & $sExtension Then ; _WindowsCleanup soll verhindern, dass von Windows nicht akzeptierte Zeichen im Dateinamen landen.
					FileWrite($hIgnorelist, $sFilename & @CRLF)
					If $sUnderlines = 1 Then
						FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\" & StringReplace(_WindowsCleanup($aResultnames[$iIndex][1]), " ", "_") & $sExtension)
						$sFilename = StringReplace(_WindowsCleanup($aResultnames[$iIndex][1]), " ", "_")
					Else
						FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\" & _WindowsCleanup($aResultnames[$iIndex][1]) & $sExtension)
						$sFilename = _WindowsCleanup($aResultnames[$iIndex][1])
					EndIf
				EndIf

				; Nun wird die Detailsuche-Funktion mit den Parametern gestartet.
				_GetMovieInfo($aResultnames[$iIndex][2], $aResultnames[$iIndex][1], $aResultnames[$iIndex][3])
				FileWrite($hIgnorelist, $sFilename & @CRLF)
				Return
			EndIf
		EndIf
		; Wenn "Automatik" auf zwei steht, wird bei unklaren Ergebnissen keine GUI erstellt. Das Skript übergeht die nächsten Schritte einfach.
		If $sNoConfirmation <> 3 And $sNoConfirmation <> 4 Then
			; Hier kommt die GUI
			#Region GUI
			$hGUI = GUICreate("filmstarts.de-Textsuche", 400, 450, @DesktopWidth / 2 - 400)
			GUISetIcon(@ScriptDir & "Other\Icon.ico")
			GUISetBkColor(0x464646, $hGUI)
			GUICtrlSetDefColor(0xFFD948, $hGUI)
			$idEdit = GUICtrlCreateLabel("Suchbegriff bearbeiten", 20, 10, 80, 40)
			$idIgnoreOnce = GUICtrlCreateLabel("Zum nächsten Titel", 170, 10, 80, 40)
			$idIgnoreAllways = GUICtrlCreateLabel("Titel dauerhaft ignorieren", 320, 10, 80, 40)
			$idWorking = GUICtrlCreateLabel("", 0, 0, 400, 40)
			GUICtrlSetBkColor($idWorking, 0xFFD948)
			GUICtrlSetState($idWorking, $GUI_HIDE)
			GUICtrlCreateLabel("Suche läuft, bitte warten..", 90, 210, 275, 30)
			GUICtrlSetFont(-1, 12, 800)
			GUICtrlSetState(-1, $GUI_DISABLE)
			GUISetState(@SW_SHOW, $hGUI)
			$hChild = GUICreate("", 400, 400, 0, 50, $WS_POPUP, $WS_EX_MDICHILD, $hGUI)
			GUISetBkColor(0x404040, $hChild)
			GUICtrlSetDefColor(0xD8E7F5, $hChild)
			#EndRegion GUI

			; Hier werden die Controls (anklickbare Bilder und Labels) in einer Schleife erstellt, wenn es Treffer gibt.
			If $iHits <> 0 Then
				For $i = 0 To $iHits - 1
					$hDownload = InetGet($aResultnames[$i][0], @ScriptDir & "\Pic" & $i, 1, 1)
					Do
						Sleep(15)
					Until InetGetInfo($hDownload, $INET_DOWNLOADCOMPLETE)

					$idPic[$i] = GUICtrlCreatePic(@ScriptDir & "\Pic" & $i, 20, $iTop, 75, 100)
					$idLabel[$i] = GUICtrlCreateLabel($aResultnames[$i][1] & " (" & $aResultnames[$i][3] & ")", 110, $iTop + 40, 275, 45)
					GUICtrlSetFont(-1, 10, 600, 0, "Segoe UI", 5)
					FileDelete(@ScriptDir & "\Pic" & $i)
					$iTop += 110
				Next
			Else
				$idLabel = GUICtrlCreateLabel("Keine Ergebnisse..", 110, $iTop + 40, 275, 30)
				GUICtrlSetFont($idLabel, 12, 800)
				GUICtrlSetState($idLabel, $GUI_DISABLE)
			EndIf

			GUISetState(@SW_SHOW, $hChild)

			; Wenn mehr als 3 Bilder dargestellt werden müssen, wird die Scrollbars UDF aufgerufen.
			If $iHits > 3 Then _GUIScrollbars_Generate($hChild, 0, 30 + 110 * $iHits, 0, 0, Default, 7)

			; Hier die While Schleife für die GUI-Ereignisse.
			While 1
				$hGUIMsg = GUIGetMsg()

				Switch $hGUIMsg
					Case $GUI_EVENT_CLOSE
						ExitLoop
					Case $idEdit
						$sNewMovie = InputBox("Suchbegriff", "Hier kannst du den Suchbegriff modifizieren, um bessere Ergebnisse zu erhalten.", $sMoviename)
						If $sNewMovie <> "" And $sNewMovie <> $sMoviename Then
							GUIDelete($hGUI)
							GUIDelete($hChild)
							_SearchMovies($sNewMovie)
							Return
						EndIf
					Case $idIgnoreOnce
						GUICtrlSetData($h_Log, $sMoviename & 'wird in diesem Lauf ignoriert.' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
						GUIDelete($hGUI)
						GUIDelete($hChild)
						Return
					Case $idIgnoreAllways
						FileWrite($hIgnorelist, $sFilename & @CRLF)
						GUICtrlSetData($h_Log, $sMoviename & 'wird dauerhaft ignoriert.' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
						GUIDelete($hGUI)
						GUIDelete($hChild)
						Return
				EndSwitch

				; Hier wird kontrolliert, welches der in Schleife erstellten Controls angeklickt wurde.
				If $hGUIMsg > 0 Then
					For $i = 0 To $iHits - 1
						If ($hGUIMsg = $idPic[$i]) Or ($hGUIMsg = $idLabel[$i]) Then
							GUICtrlSetState($idWorking, $GUI_SHOW)

							; Hier werden wieder Einstellungen überprüft. Soll die Datei umbenannt werden, wenn ja, wie?
							If $sResolve = 1 And $sFilename & $sExtension <> _WindowsCleanup($aResultnames[$i][1]) & $sExtension Then
								FileWrite($hIgnorelist, $sFilename & @CRLF)
								If $sUnderlines = 1 Then
									FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & StringReplace(_WindowsCleanup($aResultnames[$i][1]), " ", "_") & $sExtension)
									$sFilename = StringReplace(_WindowsCleanup($aResultnames[$i][1]), " ", "_")
								Else
									FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\" & _WindowsCleanup($aResultnames[$i][1]) & $sExtension)
									$sFilename = _WindowsCleanup($aResultnames[$i][1])
								EndIf
							EndIf
							GUICtrlSetData($h_Log, 'Beschreibung für ' & $aResultnames[$i][1] & ' ausgewählt' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))

							; Die Film-Detailinformationen werden in der _GetMovieInfo-Funktion abgerufen.
							_GetMovieInfo($aResultnames[$i][2], $aResultnames[$i][1], $aResultnames[$i][3])
							FileWrite($hIgnorelist, $sFilename & @CRLF)
							GUIDelete($hGUI)
							GUIDelete($hChild)
							Return
						EndIf
					Next
				EndIf
			WEnd
		Else
			Return
		EndIf
		; MediaInfo.dll wird vor dem Beenden freigegeben.
		DllCall($hDLL, "none", "MediaInfo_Close", "ptr", $hMediaInfo)
		DllClose($hDLL)

		Exit
	Else
		MsgBox(0, $sMoviename, "0 Ergebnisse")
	EndIf
EndFunc   ;==>_SearchMovies

Func _GetMovieInfo($sAdress, $sMoviename, $Year)

	; Für die die spätere Übergabe an IMDb wird hier der Treffertitel gespeichert, bevor er später möglicherweise wegen Option verändert wird
	$sFoundTitel = $sMoviename

	$filmstart_Infos = '|' & $sAdress & ';' & $sMoviename & ';' & $Year & '|'
;~ MsgBox(0,"",$filmstart_Infos)
	$sSearch = _INetGetSource($sAdress, True)

	; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
	$dBinary = StringToBinary($sSearch)
	$sConverted = BinaryToString($dBinary, 4)

	Local $aMoviedetails[1][3], $sGenre, $iFSK = 0, $iFSKFound = ""

	; In den folgenden Zeilen, werden die Filminformationen aus dem Quelltext gelesen.
	$aGenre = _StringBetween($sConverted, '<span itemprop="genre">', '</span>') ; Hier wird das Genre geholt..

	For $i = 0 To UBound($aGenre) - 1
		$sGenre &= $aGenre[$i] & ","
	Next
	$aMoviedetails[0][2] = StringTrimRight($sGenre, 1)

	$aMainGenre = StringSplit($aMoviedetails[0][2], ",")
	$sMainGenre = _GenreNumber($aMainGenre[1])

	$aPlot = _StringBetween($sConverted, 'itemprop="description">', ' </div>')
	If IsArray($aPlot) Then
		If StringLeft($aPlot[0], 1) = " " Then $aPlot[0] = StringTrimLeft($aPlot[0], 1)
		$aMoviedetails[0][1] = $aPlot[0]
	Else
		$aMoviedetails[0][1] = ""
	EndIf

	$aFSK = _StringBetween($sConverted, '"synopsis-certificate danger">FSK ab ', ' freigegeben</span>')
	If IsArray($aFSK) Then
		$iFSK = $aFSK[0]
	EndIf


	$aPicture = _StringBetween($sConverted, '"og:image" content="', '" />')
	If IsArray($aFSK) Then
		$aMoviedetails[0][0] = $aPicture[0]
	Else
		$aMoviedetails[0][0] = ""
	EndIf



	; Hier wird einfach mal das Genre in $Info1 gespeichert, weil gleich gefragt werden soll, ob evtl. der Titel 2 in Info1 stehen soll.
	$sInfo1 = $aMoviedetails[0][2]

	; Hier wird ob etwas in $Info1 eingetragen werden soll und wenn ja, was?
	If $sInfo1Option = 0 Then
		$sInfo1 = ""
		; Hier wird geprüft, ob die Option Titel statt Genre in Info1 aktiviert ist.
	ElseIf $sInfo1Option = 1 Then
		If StringInStr($sMoviename, ": ") Or StringInStr($sMoviename, " - ") Then
			$sQuestion = MsgBox(4, "Frage zum Titel", "Der Titel: " & $sMoviename & " beeinhaltet :/- " & @CRLF & "Soll nur der erste Teil als Name verwendet werden und statt dem Genre, der zweite Teil in Info1 stehen?")
			; Wenn die Frage mit 'Ja' beantwortet wurde, wird der Titel gesplittet und Name mit Split1 gefüllt und die Variable $Info1 mit Split2.
			If $sQuestion = 6 Then
				If StringInStr($sMoviename, ": ") Then
					$aName = StringSplit($sMoviename, ":")
					$sMoviename = $aName[1]
					$sInfo1 = StringTrimLeft($aName[2], 1)
				EndIf
				If StringInStr($sMoviename, " - ") Then
					$aName = StringSplit($sMoviename, "-")
					$sMoviename = StringTrimRight($aName[1], 1)
					$sInfo1 = StringTrimLeft($aName[2], 1)
				EndIf
			EndIf
		EndIf
	EndIf

	; Hier und in folgenden Schritten wird geprüft, ob die Ergebnisse in ein separates Verzeichnis gespeichert werden sollen. Wenn ja, wird es hier erstellt.
	If $sNoExtraFolder <> 1 Then DirCreate($sDrive & $sDir & "\" & $sName & "_Ergebnisse")

	; Hier wird das Bild geladen, wenn die Daten vorhanden sind.
	If $sNoExtraFolder = 1 Then
		If $sOutputFilter <> 3 And $aMoviedetails[0][0] <> "" Then InetGet($aMoviedetails[0][0], $sDrive & $sDir & "\" & $sFilename & ".jpg", 1, 1)
	Else
		If $sOutputFilter <> 3 And $aMoviedetails[0][0] <> "" Then InetGet($aMoviedetails[0][0], $sDrive & $sDir & "\" & $sName & "_Ergebnisse\" & $sFilename & ".jpg", 1, 1)
	EndIf

	If $sOutputFilter <> 2 Then
		If $mediainfo = 1 Then
			GUICtrlSetData($h_Log, 'MediaInfo untersucht die Datei: ' & $sMoviename & $sExtension & ' ..' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
			_MediaInfo()
		EndIf
		If $sIMDbInfos <> 0 Then
			_IMDbMovielist($sFoundTitel, $Year)
		Else
			$sReleaseYear = "0"
			$sCountry = ""
			$sRating = "0"
		EndIf

		If $sIMDbID <> "" Then $sIMDbID = @LF & "IMDb ID: " & $sIMDbID

		; Hier wird die XML geschrieben.
		If $sNoExtraFolder = 1 Then
			$hXML = FileOpen($sDrive & $sDir & "\" & $sFilename & ".xml", 266)
		Else
			$hXML = FileOpen($sDrive & $sDir & "\" & $sName & "_Ergebnisse\" & $sFilename & ".xml", 266)
		EndIf
		If $hXML <> -1 Then

			$sXML_Content = '<?xml version="1.0" encoding="UTF-8"?>' & @LF & @LF & '<neutrino commandversion="1">' & @LF & '	<record command="record">' & @LF & '		<channelname>Movieplayer</channelname>' & @LF & '		<epgtitle>'
			$sXML_Content &= $sMoviename & '</epgtitle>' & @LF & '		<id>0</id>' & @LF & '		<info1>' & $sInfo1 & '</info1>' & @LF & '		<info2>' & _TextCleanup($aMoviedetails[0][1]) & $sIMDbID & $sExtFileData & '</info2>' & @LF
			$sXML_Content &= '		<epgid>0</epgid>' & @LF & '		<mode>0</mode>' & @LF & '		<videopid>0</videopid>' & @LF & '		<videotype>0</videotype>' & @LF

			; Mit eingefügten Audiospuren, hat die Box Probleme. Daher erst einmal nur als Option übernommen.
			If $sAudioInfos = 1 Then $sXML_Content &= '		<audiopids>' & @LF & $sSoundtrack & '		</audiopids>' & @LF

			$sXML_Content &= '		<vtxtpid>0</vtxtpid>' & @LF & '		<genremajor>' & $sMainGenre & '</genremajor>' & @LF & '		<genreminor>0</genreminor>' & @LF
			$sXML_Content &= '		<seriename></seriename>' & @LF & '		<length>' & $sDuration & '</length>' & @LF & '		<productioncountry>' & $sCountry & '</productioncountry>' & @LF & '		<productiondate>' & $sReleaseYear & '</productiondate>' & @LF & '		<rating>' & $sRating & '</rating>' & @LF & '		<quality>0</quality>' & @LF
			$sXML_Content &= '		<parentallockage>' & $iFSK & '</parentallockage>' & @LF & '		<dateoflastplay></dateoflastplay>' & @LF & '		<bookmark>' & @LF & '			<bookmarkstart>0</bookmarkstart>' & @LF & '			<bookmarkend>0</bookmarkend>' & @LF
			$sXML_Content &= '			<bookmarklast>0</bookmarklast>' & @LF & '			<bookmarkuser bookmarkuserpos="0" bookmarkusertype="0" bookmarkusername=""/>' & @LF & '		</bookmark>' & @LF & '	</record>' & @LF & '</neutrino>' & @LF

			FileWrite($hXML, $sXML_Content)
			FileClose($hXML)
		Else
			MsgBox(0, $sFilename & ".xml", "Fehler beim Schreiben der Daten.", 5)
		EndIf
		FileClose($hXML)

		If $archiv = 1 Then
			InetGet($aMoviedetails[0][0], $hArchivFolder & "\" & $sFilename & ".jpg", 1, 1)
			$hXML_Achiv = FileOpen($hArchivFolder & "\" & $sFilename & ".xml", 266)
			If $hXML_Achiv <> -1 Then
				FileWrite($hXML_Achiv, $sXML_Content)
			Else
				MsgBox(0, $sFilename & ".xml", "Fehler beim Schreiben der Daten.", 5)
			EndIf
			FileClose($hXML_Achiv)
		EndIf
		GUICtrlSetData($h_Log, 'Arbeit an ' & $sMoviename & ' beendet.' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))

	EndIf
EndFunc   ;==>_GetMovieInfo

Func _IMDbMovielist($sMoviename, $Year)
	$sSearchname = _ascii($sMoviename)

	Local $Adress = "http://www.IMDb.com/find?ref_=nv_sr_fn&q=" & StringReplace($sSearchname, " ", "+") & "&s=all", $sSearch = _INetGetSource($Adress, True), $sFilmAdress = "", $iHits = 1
	Local $iIMDbHits = "", $PerfectMatch = "" ; $PerfectMatch ist das Flag für erfolgreiche Suche

	; Dies sind die Standardwerte in der XML
	$sReleaseYear = "0"
	$sCountry = ""
	$sRating = "0"
	$sIMDbID = ""

	; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
	$dBinary = StringToBinary($sSearch)
	$sSearch = BinaryToString($dBinary, 4)

	; Falls Schauspieler mit dem Filmtitel als Spitznamen gelistet sind, muss die Suche etwas geändert werden.
	If StringInStr($sSearch, '<h3 class="findSectionHeader"><a name="nm"></a>Names</h3>') Then

		$aResults = _StringBetween($sSearch, '</a>Titles</h3>' & @LF & '<table class="findList">', '</tr></table>') ; mit Schauspielern
	Else
		$aResults = _StringBetween($sSearch, '<table class="findList">', '</tr></table>')
	EndIf
;~ 	_ArrayDisplay($aResults, @ScriptLineNumber)
	If @error Then
		ConsoleWrite(@ScriptLineNumber & ': Keine IMDb Filmliste gefunden bei ' & $sMoviename)
		$iHits = 0

	EndIf
	If $iHits <> 0 Then
;~ _ArrayDisplay($aResults)
		Local $aPics = _StringBetween($aResults[0], '<img src="', '" />')
;~ _ArrayDisplay($aPics)
		Local $aMovieAdress = _StringBetween($aResults[0], 't"> <a href="', '" >')
;~ _ArrayDisplay($aMovieAdress)
		Local $aMovies = _StringBetween($aResults[0], ' <a href="', ' </td>')
;~ _ArrayDisplay($aMovies)
		Local $aMovieInfos[0][4]
		Local $iCount = 0

		For $i = 0 To UBound($aMovies) - 1

			If Not StringInStr($aMovies[$i], '<img src=') Then

				$aSplit = StringSplit($aMovies[$i], '>')
				$aSplit[3] = StringReplace($aSplit[3], '<br/', '') ; dies sind das Jahr und der Kommentar wie (TV Movies) oder (I)

				; Von $aSplit[3] möchte ich nur noch das Datum haben.
				StringReplace($aSplit[3], '(', '')
				If @extended > 1 Then
					Local $aData = _StringBetween($aSplit[3], '(', ')')
					For $ii = 0 To UBound($aData) - 1
						If StringLen($aData[$ii]) = 4 And StringLen(Int($aData[$ii])) = 4 Then
							$aSplit[3] = ' (' & $aData[$ii] & ')'
						EndIf
					Next
				EndIf
				$sSplit = StringTrimRight($aSplit[2], 3) & '|' & $aSplit[3] & '|' & $aPics[$iCount] & '|' & $aMovieAdress[$iCount]
				_ArrayAdd($aMovieInfos, $sSplit, 0, '|')
				$iCount += 1
			EndIf
		Next
;~ _ArrayDisplay($aMovieInfos, @ScriptLineNumber)

		; Erster Schritt der Suche: Perfekter Match. Es wird nach identischer Schreibweise im Namen gesucht.
		$aPerfectName = _ArrayFindAll($aMovieInfos, $sMoviename, 0, 0, 0, 0, 0)
		If Not @error Then
;~ 		_ArrayDisplay($aMovieInfos, @ScriptLineNumber)
			Local $iMaxvalue = _ArrayMax($aPerfectName)
			; Gibt es bei den genauen Namen auch das richtige Jahr?
			$aPerfectYear = _ArrayFindAll($aMovieInfos, ' (' & $Year & ')', $aPerfectName[0], $iMaxvalue, 0, 0, 1)
			If Not @error Then
;~ 			_ArrayDisplay($aPerfectYear, @ScriptLineNumber)
				; Wenn es nur einen Treffer mit korrektem Namen und Jahr gibt, wird der Titel übernommen
				If UBound($aPerfectYear) = 1 Then
					$iIMDbHits = 1
					$aSearchindex = $aPerfectYear[0]
					$PerfectMatch = 1
				EndIf
			EndIf
		EndIf

		If $PerfectMatch = "" Then
			$aSearchindex = _ArrayFindAll($aMovieInfos, $sMoviename, 0, 0, 0, 1, 0)

			If Not @error Then
				$iIMDbHits = UBound($aSearchindex)
			Else
				$aSearchindex2 = _ArrayFindAll($aMovieInfos, ' (' & $Year & ')', 0, 0, 0, 1, 1)

				If @error Then
					$iIMDbHits = UBound($aMovieInfos)
					Local $aSearchindex[$iIMDbHits]
					For $i = 0 To $iIMDbHits - 1
						$aSearchindex[$i] = $i
					Next
				Else
					$iIMDbHits = UBound($aSearchindex2)
					Local $aSearchindex[$iIMDbHits]
					For $i = 0 To $iIMDbHits - 1
						$aSearchindex[$i] = $aSearchindex2[$i]
					Next
				EndIf
			EndIf
		EndIf

		If $iIMDbHits = 1 Then
			$sIMDbFilmAdress = 'http://www.IMDb.com' & $aMovieInfos[$aSearchindex][3]
			GUICtrlSetData($h_Log, 'IMDb-Daten von ' & $aMovieInfos[$aSearchindex][0] & ' automatisch übernommen..' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
			$sIMDb_Infos = '|' & $sIMDbFilmAdress & ';' & $aMovieInfos[$aSearchindex][0] & ';' & $aMovieInfos[$aSearchindex][1] & '|'
			$adrSplit = StringSplit($sIMDbFilmAdress, '/')
			$sIMDbID = $adrSplit[5]

			_IMDbMovieGrab($sMoviename, $sIMDbFilmAdress)
;~ MsgBox(0,"",$sFilmAdress)
		EndIf
;~ 	_ArrayDisplay($aSearchindex, "Alle Treffer")
	EndIf
	If $iIMDbHits <> 1 Then
		Local $iTop = 30, $idPic[$iIMDbHits], $idLabel[$iIMDbHits]

		; Wenn "Automatik" auf zwei steht, wird bei unklaren Ergebnissen keine GUI erstellt. Das Skript übergeht die nächsten Schritte einfach.
		If $sNoConfirmation <> 3 And $sNoConfirmation <> 4 Then


			Local $DownloadTest
			For $i = 0 To $iIMDbHits - 1
				$iIndex = $aSearchindex[$i]
				$DownloadTest = InetGet($aMovieInfos[$iIndex][2], @ScriptDir & "\Pic" & $i, 1, 1)
			Next
			For $i = 0 To 150
				If Not (InetGetInfo($DownloadTest, $INET_DOWNLOADCOMPLETE)) Then
					Sleep(10)
				Else
					ExitLoop
				EndIf
			Next

			; Hier kommt die GUI
			#Region GUI
			$hGUI = GUICreate("IMDb-Suche nicht eindeutig: " & $sMoviename, 400, 450, @DesktopWidth / 2 - 400)
			GUISetIcon(@ScriptDir & "Other\Icon.ico")
			GUISetBkColor(0x464646, $hGUI)
			GUICtrlSetDefColor(0xFFD948, $hGUI)
			$idEdit = GUICtrlCreateLabel("Suchbegriff bearbeiten", 20, 10, 80, 40)
			$idIgnoreOnce = GUICtrlCreateLabel("Übergehen", 170, 10, 80, 40)
			$idWorking = GUICtrlCreateLabel("", 0, 0, 400, 40)
			GUICtrlSetBkColor($idWorking, 0xFFD948)
			GUICtrlSetState($idWorking, $GUI_HIDE)
			GUISetState(@SW_SHOW, $hGUI)
			$hChild = GUICreate("", 400, 400, 0, 50, $WS_POPUP, $WS_EX_MDICHILD, $hGUI)
			GUISetBkColor(0x282828, $hChild)
			GUICtrlSetDefColor(0xD8E7F5, $hChild)
			#EndRegion GUI

			; Hier werden die Controls (anklickbare Bilder und Labels) in einer Schleife erstellt, wenn es Treffer gibt.
			If $iHits <> 0 Then

				For $i = 0 To $iIMDbHits - 1
					$iIndex = $aSearchindex[$i]
					$hDownload = InetGet($aMovieInfos[$iIndex][2], @ScriptDir & "\Pic" & $i, 1, 1)
					Do
						Sleep(15)
					Until InetGetInfo($hDownload, $INET_DOWNLOADCOMPLETE)
					$idPic[$i] = GUICtrlCreatePic(@ScriptDir & "\Pic" & $i, 20, $iTop, 50, 75)
					$idLabel[$i] = GUICtrlCreateLabel($aMovieInfos[$iIndex][0] & $aMovieInfos[$iIndex][1], 90, $iTop + 25, 275, 45)
					GUICtrlSetFont(-1, 10, 600, 0, "Segoe UI", 5)
					FileDelete(@ScriptDir & "\Pic" & $i)
					$iTop += 85
				Next
			Else
				$idLabel = GUICtrlCreateLabel("Keine Ergebnisse..", 110, $iTop + 40, 275, 30)
				GUICtrlSetFont($idLabel, 12, 800)
				GUICtrlSetState($idLabel, $GUI_DISABLE)
			EndIf

			GUISetState(@SW_SHOW, $hChild)

			; Wenn mehr als 3 Bilder dargestellt werden müssen, wird die Scrollbars UDF aufgerufen.
			If $iIMDbHits > 3 Then _GUIScrollbars_Generate($hChild, 0, 30 + 85 * $iIMDbHits, 0, 0, Default, 7)

			; Hier die While Schleife für die GUI-Ereignisse.
			While 1
				$hGUIMsg = GUIGetMsg()

				Switch $hGUIMsg
					Case $GUI_EVENT_CLOSE
						GUICtrlSetData($h_Log, 'IMDb-Daten von ' & $sMoviename & ' wurden ausgelassen.' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
						GUIDelete($hGUI)
						GUIDelete($hChild)
						Return
					Case $idEdit
						$sNewMovie = InputBox("Suchbegriff", "Hier kannst du den Suchbegriff modifizieren, um bessere Ergebnisse zu erhalten.", $sMoviename)
						If Not @error Then
							If $sNewMovie <> "" And $sNewMovie <> $sMoviename Then
								GUIDelete($hGUI)
								GUIDelete($hChild)
								_IMDbMovielist($sNewMovie, $Year)
								Return
							EndIf
						Else
;~ 							MsgBox(0, $sNewMovie, $sMoviename)
						EndIf
					Case $idIgnoreOnce
						GUICtrlSetData($h_Log, 'IMDb-Daten von ' & $sMoviename & ' wurden ausgelassen.' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
						GUIDelete($hGUI)
						GUIDelete($hChild)
						Return
				EndSwitch

				; Hier wird kontrolliert, welches der in Schleife erstellten Controls angeklickt wurde.
				If $hGUIMsg > $idEdit Then
					For $i = 0 To $iIMDbHits - 1
						If ($hGUIMsg = $idPic[$i]) Or ($hGUIMsg = $idLabel[$i]) Then
							$sIMDbFilmAdress = 'http://www.IMDb.com' & $aMovieInfos[$i][3]
							GUICtrlSetData($h_Log, 'IMDb-Daten von ' & $aMovieInfos[$i][0] & $aMovieInfos[$i][1] & ' manuell übernommen..' & ' (' & $iGlobalRun & '/' & $iFoundMovies & ')' & @CRLF & GUICtrlRead($h_Log))
							$sIMDb_Infos = '|' & $sIMDbFilmAdress & ';' & $aMovieInfos[$i][0] & ';' & $aMovieInfos[$i][1] & '|'
							GUIDelete($hGUI)
							GUIDelete($hChild)
							_IMDbMovieGrab($sMoviename, $sIMDbFilmAdress)
						EndIf
					Next
					ExitLoop
				EndIf
			WEnd
		Else
			Return
		EndIf
	EndIf
EndFunc   ;==>_IMDbMovielist

Func _IMDbMovieGrab($sMoviename, $sIMDbFilmAdress)

	$sSearch = _INetGetSource($sIMDbFilmAdress, True)

	; Hier wird der String zur korrekten Anzeige der Sonderzeichen konvertiert
	$dBinary = StringToBinary($sSearch)
	$sSearch = BinaryToString($dBinary, 4)

	$aResult = _StringBetween($sSearch, 'class="rating">', '<span')
	If Not @error Then
		$sRating = StringReplace($aResult[0], '.', '')
		If StringLen($sRating) = 1 Then
			$sRating = $sRating & 0
		EndIf
	Else
		ConsoleWrite(@ScriptLineNumber & ': Suchstring für "Rating" nicht gefunden bei ' & $sMoviename)
		$sRating = 0
	EndIf

	$aResult = _StringBetween($sSearch, 'Country:</h4>', '</a>')

	If @error Then
		ConsoleWrite(@ScriptLineNumber & ': Erster Suchstring für "Country" nicht gefunden bei ' & $sMoviename)
	Else
		$aResultSplit = StringSplit($aResult[0], '>')
		If Not @error Then
			$sCountry = $aResultSplit[2]
		Else
			ConsoleWrite(@ScriptLineNumber & ': Suchstring für "Country" nicht gefunden bei ' & $sMoviename)
			$sCountry = ''
		EndIf
	EndIf

	$aResult = _StringBetween($sSearch, '<title>', '</title>')
	If @error Then
		ConsoleWrite(@ScriptLineNumber & ': Erster Suchstring für "Year" nicht gefunden bei ' & $sMoviename)
	Else
		$aResult = _StringBetween($aResult[0], '(', ')')
		If Not @error Then
			$sReleaseYear = $aResult[0]
		Else
			ConsoleWrite(@ScriptLineNumber & ': Zweiter Suchstring für "Year" nicht gefunden bei ' & $sMoviename)
			$sReleaseYear = 0
		EndIf
	EndIf
EndFunc   ;==>_IMDbMovieGrab

Func _TextCleanup(ByRef $sString)
	For $i = 0 To UBound($aSubstitutes) - 1
		$sString = StringReplace($sString, $aSubstitutes[$i][0], $aSubstitutes[$i][1])
	Next
	Return $sString
EndFunc   ;==>_TextCleanup

Func _WindowsCleanup($sString)
	For $i = 0 To 8
		$sString = StringReplace($sString, $aWindowsCleanup[$i][0], "")
	Next
	If $sCharset = 1 Then
		$dBinary = StringToBinary($sString, 4)
		$sString = BinaryToString($dBinary)
	EndIf
	Return $sString
EndFunc   ;==>_WindowsCleanup

Func _GenreNumber($sGenreText)
	For $i = 0 To UBound($aGenreNumbers) - 1
		$sGenreText = StringReplace($sGenreText, $aGenreNumbers[$i][0], $aGenreNumbers[$i][1])
		If @extended <> 0 Then Return $aGenreNumbers[$i][1]
	Next
	Return 0
EndFunc   ;==>_GenreNumber

Func _ChannelCleanup($sMoviename)
	For $i = 0 To $iSearchlines - 2
		$sNewMoviename = StringReplace($sMoviename, $aChannels[$i], "", 1, 1)
		If @extended <> 0 Then Return $sNewMoviename
	Next
	Return $sMoviename
EndFunc   ;==>_ChannelCleanup

Func _ascii($sString)
	For $i = 0 To UBound($aAscii) - 1
		$sString = StringReplace($sString, $aAscii[$i][0], $aAscii[$i][1], 0, 1)
	Next
	Return $sString
EndFunc   ;==>_ascii

Func _MediaInfo()

	; Hier werden die Mediafile-Informationen mithilfe der MediaInfo.dll abgerufen. Bei Fragen am besten die dll direkt von der Projektseite laden. Da gibt es Beispiele anbei.

	DllCall($hDLL, "dword", "MediaInfo_Open", "ptr", $hMediaInfo, "wstr", $sDrive & $sDir & $sFilename & $sExtension)
	; ; Wenn "MediaInfotext" aktiviert ist, werden hier die Mediafile-Informationen als Textdatei geschrieben.
	If ($sMediaInfoText = 1) Or ($sMediaInfoText = 2) Then
		If $sNoExtraFolder = 1 Then
			DirCreate($sDrive & $sDir & "\MediaInfo-Ausgaben")
			FileDelete($sDrive & $sDir & "\MediaInfo-Ausgaben\" & $sFilename & $sExtension & ".txt")
			$aMediaInfoInform = DllCall($hDLL, "wstr", "MediaInfo_Inform", "ptr", $hMediaInfo, "int", 0)
			FileWrite($sDrive & $sDir & "\MediaInfo-Ausgaben\" & $sFilename & $sExtension & ".txt", $aMediaInfoInform[0])
		Else
			DirCreate($sDrive & $sDir & "\" & $sName & "_Ergebnisse\MediaInfo-Ausgaben")
			FileDelete($sDrive & $sDir & "\" & $sName & "_Ergebnisse\MediaInfo-Ausgaben\" & $sFilename & $sExtension & ".txt")
			$aMediaInfoInform = DllCall($hDLL, "wstr", "MediaInfo_Inform", "ptr", $hMediaInfo, "int", 0)
			FileWrite($sDrive & $sDir & "\" & $sName & "_Ergebnisse\MediaInfo-Ausgaben\" & $sFilename & $sExtension & ".txt", $aMediaInfoInform[0])
		EndIf
	EndIf
	; Ende Textausgabe

	If ($sExtInfo = 1) And Not ($sMediaInfoText = 2) Then
		; Generelle Dateiangaben
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 0, "int", 0, "wstr", "Format", "int", 1, "int", 0)
		$sFormat = $aMediaInfoGet[0]
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "CodecID", "int", 1, "int", 0)
		$sVideoCodec = $aMediaInfoGet[0]
		If $sVideoCodec = 2 Then $sVideoCodec = "MPEG-2"
		If $sVideoCodec = 27 Then $sVideoCodec = "MPEG-4-AVC"
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "Width", "int", 1, "int", 0)
		$sWidth = $aMediaInfoGet[0]
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "Height", "int", 1, "int", 0)
		$sHeight = $aMediaInfoGet[0]
		$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "BitRate/String", "int", 1, "int", 0)
		If $aMediaInfoGet[0] <> "" Then
			$sBitRate = " | " & "Videobitrate: " & StringTrimRight(StringReplace($aMediaInfoGet[0], " ", "."), 5) & " Kbps"
		Else
			$sBitRate = ""
		EndIf
		If $sFormat <> "" Then $sExtFileData = @LF & "Container: " & $sFormat & " | " & "Codec: " & $sVideoCodec & " | " & "Auflösung: " & $sWidth & "x" & $sHeight & $sBitRate
	EndIf
	If ($sMediaInfoText = 3) Then
		If $sWidth <> "" Then
			$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 1, "int", 0, "wstr", "Width", "int", 1, "int", 0)
			$sWidth = $aMediaInfoGet[0]
			If $sWidth >= 1920 Then FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\Full HD\" & $sFilename & $sExtension, 8)
			If $sWidth >= 1280 And $sWidth < 1920 Then FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\HD Ready\" & $sFilename & $sExtension, 8)
			If $sWidth < 1280 Then FileMove($sDrive & $sDir & "\" & $sFilename & $sExtension, $sDrive & $sDir & "\SD\" & $sFilename & $sExtension, 8)
		EndIf
	EndIf

	; Hier rufe ich die Dauer und bilde die Angabe, die MediaInfo ausgibt. Das Ergebnis unterscheidet sich hier aber von Neutrino. Neutrino rundet auf und ab. MediaInfo nimmt die vollständigen Minuten. Das passt auch zu den offiziellen Angaben.
	$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 0, "int", 0, "wstr", "Duration", "int", 1, "int", 0)
	$sDuration = $aMediaInfoGet[0]
	$sDuration = Round($sDuration / 60000, 1)
	If StringInStr($sDuration, ".") Then $sDuration = StringTrimRight($sDuration, 2)


	; Mit eingefügten Audiospuren, hat die Box momentan Probleme. Daher erst einmal nur als Option übernommen.
	If $sAudioInfos = 1 Then
		; Audiodaten
		$iSelected = 1

		; Es kann maximal 9 Tonspuren geben. Daher läuft die Schleife 9 Mal, falls vorher vorher schon keine neue Tonspur gefunden wird.
		For $i = 0 To 9
			If $i <> 0 Then $iSelected = 0
			$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 2, "int", $i, "wstr", "Format", "int", 1, "int", 0)
			If $aMediaInfoGet[0] = "" Then ExitLoop
			$sAudioFormat = $aMediaInfoGet[0]
			$aMediaInfoGet = DllCall($hDLL, "wstr", "MediaInfo_Get", "ptr", $hMediaInfo, "int", 2, "int", $i, "wstr", "Language", "int", 1, "int", 0)
			If $aMediaInfoGet[0] = "" Then $aMediaInfoGet[0] = "unbekannt"
			$sLanguage = $aMediaInfoGet[0]
			$sSoundtrack &= '			<audio pid="" audiotype="1" selected="' & $iSelected & '" name="' & $sLanguage & '(' & $sAudioFormat & ')' & '"/>' & @LF
		Next
	EndIf
EndFunc   ;==>_MediaInfo

Func _IsChecked($idControlID)
	Return BitAND(GUICtrlRead($idControlID), $GUI_CHECKED) = $GUI_CHECKED
EndFunc   ;==>_IsChecked

Func _WriteIni()
	Local $sString = 'Hinweise:' & @CRLF & '- Das Programm legt die Ergebnisse in jedem Ordner den es bearbeitet in einen neuen Ordner, mit dem Programmnamen ab, damit nichts versehentlich überschrieben wird.' & @CRLF & '  (Kann unten per "Ergebnisse in das Filmverzeichnis=1" geändert werden.' & @CRLF & '- Jeder übernommene Treffer, oder jede Datei bei der "dauerhaft ignorieren" gewählt wurde, wird in eine Ignorierliste hier im Verzeichnis geschrieben.' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= '[Einstellungen]' & @CRLF & 'Ein Wert 1 bei "Rekursive Suche" sorgt dafür, dass auch Unterordner durchsucht werden.' & @CRLF & 'Bei jedem anderen Wert, bleibt die Suche auf den gewählten Ordner beschränkt:' & @CRLF & @CRLF & 'Rekursive Suche=0' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 bei "Automatik" sorgt für die direkte Übernahme wenn nur einer der Treffer wortgleich ist.' & @CRLF & 'Wird hier der Wert 2 eingetragen, werden Filme auch übernommen, wenn das Ergebnis eindeutig scheint, weil nur ein Suchtreffer gefunden wurde.' & @CRLF & 'Bei Wert 3 bearbeitet das Programm in Batchverarbeitung jeden eindeutigen, wortgleichen Treffer und übergeht die anderen.' & @CRLF & 'Bei Wert 4 übernimmt das Programm in Batchverarbeitung jeden wortgleichen Treffer und alle Einzeltreffer. Alle anderen werden übergangen.' & @CRLF & @CRLF & "Automatik=1" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Bei Wert 1 von "Ergebnisse in das Filmverzeichnis" werden die heruntergeladenen Filminformationen' & @CRLF & 'nicht in einem getrennten Ergebnisordner abgelegt werden, sondern direkt bei der Filmdatei.' & @CRLF & 'Achtung: Vorhandene Dateien werden ohne Nachfrage überschrieben!' & @CRLF & @CRLF & "Ergebnisse in das Filmverzeichnis=1" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= '"Cover/XML" kennt drei Stati. Bei allen Werten außer 2 und 3 werden Cover geladen und XML erstellt.' & @CRLF & 'Bei Wert 2 werden nur die Cover geladen.' & @CRLF & 'Bei Wert 3 werden nur die XML erstellt.' & @CRLF & @CRLF & 'Cover/XML=1' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 bei "Sendernamenfilter" sorgt für das Filtern der Sendernamen aus dem Suchbegriff.' & @CRLF & 'Vorraussetzung hierfür ist die Angabe der IP Adresse eines Receivers, von dem die Senderliste abgerufen werden kann.' & @CRLF & 'Hier kann es auch sinnvoll den Zeichensatz UTF8 einzustellen (UTF8=1, falls dies der Zeichtensatz des Systems ist.' & @CRLF & @CRLF & 'Sendernamenfilter=0' & @CRLF & 'IP=192.168.178.30' & @CRLF & 'UTF8=0' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 bei "Dateibeschreibung" sorgt dafür,' & @CRLF & "dass Info 2 noch zusätzliche Informationen angehängt werden (Container, Codec, Auflösung und Video-Bitrate." & @CRLF & 'Jede Änderung dieses Eintrags verhindert das.' & @CRLF & @CRLF & "Dateibeschreibung=1" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Bei Wert 1 von "Info1" bietet das Programm an,' & @CRLF & "einen Titel, der : oder - beinhaltet aufzusplitten und den ersten Teil als Namen, den zweiten Teil als Info1" & @CRLF & 'zu verwenden. Bei Wert 0 wird nichts eingetragen und bei jedem anderen Wert werden automatisch die Grenreangaben als Info1 übernommen.' & @CRLF & @CRLF & "Info1=2" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 bei "Dateinamenbereinigung" bedeutet, dass der gefundene Titel als neuer Dateiname verwendet wird.' & @CRLF & 'Jede Änderung dieses Eintrags verhindert das.' & @CRLF & 'Bei meinen Tests mit einer Samba-Freigabe auf den Receiver funktionierte diese Option nicht. Hier also deaktivieren, damit die XML passen.' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 bei "Unterstriche" bedeutet, dass die umbenannte Datei Unterstriche, statt Leerzeichen beinhaltet.' & @CRLF & "Jede Änderung dieses Eintrags sorgt für Leerzeichen." & @CRLF & @CRLF
	$sString &= 'Dateinamenbereinigung=0' & @CRLF & 'Unterstriche=0' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 sorgt dafür, dass Daten von IMDb geladen werden, bei 0 wird die Seite nicht abgefragt.' & @CRLF & @CRLF
	$sString &= 'IMDb=1' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 sorgt bei "MediaInfo" dafür, dass die Filmdateien mit MediaInfo untersucht werden und Länge, Codec, Auflösung.. usw ausgelesen werden.' & @CRLF & @CRLF
	$sString &= 'MediaInfo=1' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 bei "MediaInfotext" sorgt dafür, dass zu jedem Titel' & @CRLF & 'die allgemeine MediaInfo-Ausgabe als Textdatei in einem Unterordner des Ergebnisordners abgelegt wird.' & @CRLF & 'Bei Wert 2 werden nur diese Infodateien im Batchverfahren geschrieben.' & @CRLF
	$sString &= 'Bei Wert 3 werden alle Filme im Batchverfahren nach ihrer Auflösung in Unterordner sortiert (Full HD, HD Ready, SD.' & @CRLF & @CRLF & "MediaInfotext=0" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 sorgt dafür, dass im Unterverzeichnis Archiv, eine Kopie der gefundenen Cover und XML angelegt wird.' & @CRLF & @CRLF
	$sString &= 'Archivieren=1' & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Hier folgt das "Startverzeichnis" der Suche.' & @CRLF & 'Du kannst es erst einmal ignorieren.' & @CRLF & 'Hier wird immer der letzte gewählte Pfad gespeichert.' & @CRLF & @CRLF & 'Startverzeichnis=' & @DesktopDir & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	$sString &= 'Der Wert 1 bei "Tonspuren" sorgt dafür, dass die vorhandenen Tonspuren in die XML eingetragen werden.' & @CRLF & 'Das ist nicht nötig, da Neutrino diese selbst ermittelt. Wichtiger ist aber:' & @CRLF & 'Stand 20.05.2015 kann es zu schweren Problemen führen, wenn diese Funktion aktiviert wird!' & @CRLF & 'Also bei Fremdformat-Filmen besser deaktiviert lassen!' & @CRLF & @CRLF & "Tonspuren=0" & @CRLF & @CRLF & '-----' & @CRLF & @CRLF
	Local $hIni = FileOpen($Ini, 521)
	FileWrite($hIni, $sString)
	FileClose($hIni)
EndFunc   ;==>_WriteIni

Func _Exit()

	; MediaInfo.dll wird vor dem Beenden freigegeben.
	If IsDeclared("$hDLL") Then
		DllCall($hDLL, "none", "MediaInfo_Close", "ptr", $hMediaInfo) ; Hier wird die MediaInfo.dll aktiviert.
		DllClose($hDLL)
	EndIf
EndFunc   ;==>_Exit
